package com.borcon.aop.application;

import javax.swing.UIManager;
import java.awt.*;
import info.mangez.borcon.aop.*;
import com.borcon.aop.*;

/**
 * Borcon 2002 : 2106 - Programmation oriente aspect
 * @author Emmanuel Boudrant, Olivier Mangez
 *
 * Pour plus d'information :
 *   http://www.mangez.info
 *   http://www.mycgiserver.com/~eboudrant/borcon2002/
 */

public class Application {

  private boolean packFrame = false;

  public Application() {

    ForumLoader loader = new ForumLoader();

    MainFrame frame = new MainFrame(loader.getForumManager());

    if (packFrame) {
      frame.pack();
    } else {
      frame.validate();
    }

    centerFrame(frame);
    frame.setVisible(true);
  }

  private void centerFrame(MainFrame frame) {
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = frame.getSize();

    if (frameSize.height > screenSize.height) {
      frameSize.height = screenSize.height;
    }

    if (frameSize.width > screenSize.width) {
      frameSize.width = screenSize.width;
    }

    frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
  }

  public static void main(String[] args) {
    try {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    } catch(Exception e) {
      e.printStackTrace();
    }

    new Application();
  }
}