package com.borcon.aop.application;

import java.awt.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import java.awt.event.*;

import com.borcon.aop.business.*;

/**
 * Borcon 2002 : 2106 - Programmation oriente aspect
 * @author Emmanuel Boudrant, Olivier Mangez
 *
 * Pour plus d'information :
 *   http://www.mangez.info
 *   http://www.mycgiserver.com/~eboudrant/borcon2002/
 */

public class ChangeIdentityDialog extends JDialog {

  private JPanel panel1                = new JPanel();
  private JLabel jLabel1               = new JLabel();
  private JLabel jLabel2               = new JLabel();
  private JTextField loginField        = new JTextField();
  private JPasswordField passwordField = new JPasswordField();
  private JButton jButton1             = new JButton();
  private GridBagLayout gridBagLayout1 = new GridBagLayout();
  private BorderLayout borderLayout1   = new BorderLayout();

  private MainFrame mainFrame          = null;

  public ChangeIdentityDialog(MainFrame parent) {
    super(parent);

    mainFrame = parent;

    try {
      jbInit();
      pack();
    } catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public ChangeIdentityDialog() {
    this(null);
  }

  public Dimension getPreferredSize() {
    return new Dimension(230, 130);
  }

  private void jbInit() throws Exception {
    this.setTitle("Changer d'identit");

    panel1.setLayout(gridBagLayout1);

    jLabel1.setMaximumSize(new Dimension(74, 17));
    jLabel1.setMinimumSize(new Dimension(74, 17));
    jLabel1.setPreferredSize(new Dimension(74, 17));
    jLabel1.setToolTipText("");
    jLabel1.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabel1.setText("Nom");

    jLabel2.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabel2.setText("Mot de passe");

    loginField.setText("");
    passwordField.setText("");
    passwordField.addInputMethodListener(new java.awt.event.InputMethodListener() {
      public void inputMethodTextChanged(InputMethodEvent e) {
        passwordField_inputMethodTextChanged(e);
      }
      public void caretPositionChanged(InputMethodEvent e) {
      }
    });
    jButton1.setText("OK");
    jButton1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton1_actionPerformed(e);
      }
    });

    this.getContentPane().setLayout(borderLayout1);
    getContentPane().add(panel1, BorderLayout.CENTER);

    panel1.add(
        loginField,
        new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(10, 5, 5, 10), 0, 0)
    );

    panel1.add(
        passwordField,
        new GridBagConstraints(1, 1, 1, 1, 1.0, 0.0,
            GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 10), 0, 0)
    );

    panel1.add(
        jLabel2,
        new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0,
            GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 10, 5, 5), 0, 0)
    );

    panel1.add(
        jLabel1,
        new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0,
            GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(10, 10, 5, 5), 0, 0)
    );

    panel1.add(
        jButton1,
        new GridBagConstraints(0, 2, 2, 1, 0.0, 0.0, GridBagConstraints.CENTER,
            GridBagConstraints.NONE, new Insets(5, 10, 10, 10), 0, 0)
    );
  }

  void jButton1_actionPerformed(ActionEvent e) {
    validateIdentity();
  }

  void validateIdentity() {
    String login = loginField.getText();
    String password = new String(passwordField.getPassword());

      dispose();

    if(login.equals(password)) {
      mainFrame.setUser(new User(login));

    } else {
      mainFrame.setUser(null);

      JOptionPane.showMessageDialog(
        mainFrame,
        "L'identit que vous avez spcifi est incorrecte",
        "Erreur",
        JOptionPane.ERROR_MESSAGE
      );
    }
  }

  //Supplant, ainsi nous pouvons sortir quand la fentre est ferme
  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      dispose();
    }
    super.processWindowEvent(e);
  }

  void passwordField_inputMethodTextChanged(InputMethodEvent e) {
//    if(e.getText().last()=='\n') {
//      validateIdentity();
//    }
  }
}