package com.borcon.aop.application;

import javax.swing.*;
import java.awt.*;

import com.borcon.aop.*;
import com.borcon.aop.business.*;
import com.borcon.aop.security.*;

/**
 * Borcon 2002 : 2106 - Programmation oriente aspect
 * @author Emmanuel Boudrant, Olivier Mangez
 *
 * Pour plus d'information :
 *   http://www.mangez.info
 *   http://www.mycgiserver.com/~eboudrant/borcon2002/
 */

public class ResourceCellRender extends JLabel implements ListCellRenderer {

  private User user;

  public void setUser(User user) {
    this.user = user;
  }

  public ResourceCellRender() {
      setOpaque(true);
  }

  public Component getListCellRendererComponent(
      JList list,
      Object value,
      int index,
      boolean isSelected,
      boolean cellHasFocus) {

      if(!(value instanceof Resource)) {
        throw new IllegalArgumentException("'value' devrait tre du type Resource");
      }

      Resource resource = (Resource) value;


      try {
        setText(resource.getTitle(user));
      } catch (PermissionException ex) {
        throw new IllegalStateException("L'utilisateur n'a pas accs  cette resource");
      }

      setBackground(isSelected ? Color.blue : Color.white);
      setForeground(isSelected ? Color.white : Color.black);

      return this;
  }
}