package com.borcon.aop.business;

import java.util.*;
import com.borcon.aop.security.*;

/**
 * Borcon 2002 : 2106 - Programmation oriente aspect
 * @author Emmanuel Boudrant, Olivier Mangez
 *
 * Pour plus d'information :
 *   http://www.mangez.info
 *   http://www.mycgiserver.com/~eboudrant/borcon2002/
 */

public class Forum extends Resource {

  private ArrayList messages;

  //--------------------------------------------------------

  public Forum() {
    this(null);
  }

  public Forum(String title) {
    this.title = title;
    messages = new ArrayList();
  }

  //--------------------------------------------------------

  public void addMessage(Message message, User user) throws PermissionException {
    if(message == null) {
      throw new IllegalArgumentException("'message' ne peut pas tre nul");
    }

    message.setForum(this);
    messages.add(message);
  }

  public List getMessages(User user) throws PermissionException {
    return (List) messages.clone();
  }
}