package com.borcon.aop.trace;

/**
 * Borcon 2002 : 2106 - Programmation oriente aspect
 * @author Emmanuel Boudrant, Olivier Mangez
 *
 * Pour plus d'information :
 *   http://www.mangez.info
 *   http://www.mycgiserver.com/~eboudrant/borcon2002/
 */

public aspect Trace {

  pointcut publicMethodsPointcut() :
      execution(public * com.borcon.aop.business.*.*(..));

  before() : publicMethodsPointcut() {

    try {
      Thread.sleep(100);
    } catch (Exception ex) {
    }

    System.err.println("Excution de la mthode : " + thisJoinPoint.getSignature());
  }
}


